Attribute VB_Name = "mdlExecute"
Option Explicit
'****************************************************************************************************
'      : WW[
' @\Tv : exeNׂ̈̊֐Q
' 쐬   : 2000/05/
' XV : 2001/02/10 wb_Rgt
'----------------------------------------------------------------------------------------------------
' ˑFile : ./Registry.bas
'----------------------------------------------------------------------------------------------------
' l     :
'****************************************************************************************************

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function ShellExecuteEx Lib "shell32.dll" (ByRef sei As SHELLEXECUTEINFO) As Long
Private Declare Function WaitForInputIdle Lib "user32" (ByVal hProcess As Long, ByVal dwMilliseconds As Long) As Long
'--------------------------------------------------------------
Private Type SHELLEXECUTEINFO
    cbSize As Long
    fMask As Long
    hWnd As Long
    lpVerb As String
    lpFile As String
    lpParameters As String
    lpDirectory As String
    nShow As Long
    hInstApp As Long
    lpIDList As Long
    lpClass As String
    hkeyClass As Long
    dwHotKey As Long
    hIcon As Long
    hProcess As Long
End Type
'--------------------------------------------------------------
Private Enum EnumShellExecuteExMask
    SEE_MASK_CLASSNAME = &H1&
    SEE_MASK_CLASSKEY = &H3&
    SEE_MASK_IDLIST = &H4&
    SEE_MASK_INVOKEIDLIST = &HC&
    SEE_MASK_ICON = &H10&
    SEE_MASK_HOTKEY = &H20&
    SEE_MASK_NOCLOSEPROCESS = &H40&
    SEE_MASK_CONNECTNETDRV = &H80&
    SEE_MASK_FLAG_DDEWAIT = &H100&
    SEE_MASK_DOENVSUBST = &H200&
    SEE_MASK_FLAG_NO_UI = &H400&
    SEE_MASK_UNICODE = &H4000&
    SEE_MASK_NO_CONSOLE = &H8000&
    SEE_MASK_ASYNCOK = &H100000
    SEE_MASK_HMONITOR = &H200000
End Enum
'--------------------------------------------------------------
Private Const INFINITE       As Long = &HFFFF
Private Const SW_SHOWDEFAULT As Long = 10
'**************************************************************

' === ENbNj[ŋR}h擾 ===
Public Function GetExecuteCommand(ByVal FileName As String) As String
    Dim i As Integer
    Dim buf As String
    Dim RegKey As String
    Dim KeyList() As String
    
    't@CɃ_uNH[gĂΎ菜
    If Left$(FileName, 1) = """" Then
        FileName = Mid$(FileName, 2, Len(FileName) - 2)
    End If
    
    't@CƂĕsȕ܂܂ĂNULL
    For i = 1 To Len(FileName)
        If InStr("/,;*?""<>|", Mid$(FileName, i, 1)) > 0 Then
            GetExecuteCommand = vbNullChar
            Exit Function
        End If
    Next i
    
    't@C݂ĂȂNULL
    On Error Resume Next
    If Dir(FileName, vbNormal Or vbReadOnly Or vbSystem Or vbDirectory Or vbArchive) = "" Then
        GetExecuteCommand = vbNullChar
        Exit Function
    End If
    On Error GoTo 0
    
    'tH_Ȃ"open"
    If (GetAttr(FileName) And vbDirectory) = vbDirectory Then
        GetExecuteCommand = "open"
        Exit Function
    End If
    
    't@Cɂ
    FileName = Mid$(FileName, InStrRev(FileName, "\") + 1)
    
    'gq΋󕶎
    If InStr(FileName, ".") <= 0 Then
        GetExecuteCommand = ""
        Exit Function
    End If
    
    'gq΁AftHg̃R}hWXgT
    RegKey = "HKEY_CLASSES_ROOT\" & Mid$(FileName, InStrRev(FileName, "."))
    buf = GetRegValue(RegKey)
    
    'gqo^ĂȂ""
    If buf & "" = "" Then
        GetExecuteCommand = ""
        Exit Function
    End If
    
    'R}hT
    RegKey = "HKEY_CLASSES_ROOT\" & buf & "\Shell"
    buf = GetRegValue(RegKey)
    
    'ftHg̃R}hShellȉ̃L[񋓂đ{
    If buf & "" = "" Then
        KeyList = GetRegEnumKey(RegKey)
        'L[΍ŏ̃L[ԂAȂ""Ԃ
        If UBound(KeyList) >= 0 Then
            GetExecuteCommand = KeyList(0)
        Else
            GetExecuteCommand = ""
        End If
    Else
        GetExecuteCommand = buf
    End If
End Function

' === ֘AtꂽAvP[VPɋN ===
Public Function ShellExecute(ByVal FileName As String _
                           , Optional ByVal Parameter As String = vbNullString _
                           , Optional ByVal Command As String = "open") As Long
    Dim sei As SHELLEXECUTEINFO
    Dim rtn As Long
    Call InitSHELLEXECUTEINFO(sei)
    With sei
        .lpFile = FileName
        .lpParameters = Parameter
        .lpVerb = Command
    End With

    'N
    rtn = ShellExecuteEx(sei)

    If rtn <> API_FALSE Then
        ShellExecute = sei.hWnd
    Else
        ShellExecute = 0
    End If
End Function

' === ֘AtꂽAvP[VN ===
Public Function ExecuteFile(ByVal FileName As String, Optional ByVal Command As String = "") As Boolean
    Dim sei As SHELLEXECUTEINFO
    Dim rtn As Long
    Dim pos As Integer
    
    Call InitSHELLEXECUTEINFO(sei)
    With sei
        'AvƁAR}hCɕ
        .lpFile = FileName
        If Left$(FileName, 1) = """" Then
            pos = InStr(2, FileName, """")
            If pos > 0 Then
                .lpParameters = Mid$(FileName, pos + 2)
                .lpFile = Mid$(FileName, 2, pos - 2)
            End If
        Else
            pos = InStr(FileName, " ")
            If pos > 0 Then
                .lpParameters = Mid$(FileName, pos + 1)
                .lpFile = Left$(FileName, pos)
            End If
        End If

        ' Rs[^݂̂Ŗ'\'Ȃ炻菜
        If Left$(.lpFile, 2) = "\\" And Right$(.lpFile, 1) = "\" Then
            If UBound(Split(.lpFile, "\")) = 3 Then
                .lpFile = Left$(.lpFile, Len(.lpFile) - 1)
            End If
        End If

        'Xy[X̏
        .lpFile = Trim$(.lpFile)
        If Trim$(.lpParameters) = "" Then .lpParameters = vbNullChar
    
        .lpVerb = Command
        'R}hw肵Ȃꍇ͋\R}hɂ
        If .lpVerb = "" Then .lpVerb = GetExecuteCommand(.lpFile)
        If .lpVerb = vbNullChar Then
            't@CAtH_ł͂Ȃ̂OPEN
            .lpVerb = "open"
        ElseIf .lpVerb = "" Then
            .lpVerb = "open"
            rtn = ShellExecuteEx(sei)
            If rtn = API_FALSE Then
                .lpVerb = "open"
                .lpParameters = "Shell32.dll,OpenAs_RunDLL " & .lpFile
                .lpFile = "rundll32"
            Else
                ExecuteFile = True
                Exit Function
            End If
        End If
    End With
    
    'N
    rtn = ShellExecuteEx(sei)

    ExecuteFile = (rtn <> API_FALSE)
End Function

' === I܂őҋ@Shell֐ ===
Public Function ShellWait(ByVal FileName As String, Optional ByVal Parameter As String = vbNullChar) As Boolean
    Dim sei As SHELLEXECUTEINFO
    Dim rtn As Long
    
    Call InitSHELLEXECUTEINFO(sei)
    With sei
        .lpFile = FileName
        .lpParameters = Parameter
    End With
    
    'N
    rtn = ShellExecuteEx(sei)
    
    If rtn = API_FALSE Then
        ShellWait = False
    Else
        'ҋ@
        rtn = WaitForInputIdle(sei.hProcess, INFINITE)
        ShellWait = rtn = API_FALSE
    End If
End Function

' === SHELLEXECUTEINFO\̂̏ ===
Private Sub InitSHELLEXECUTEINFO(ByRef sei As SHELLEXECUTEINFO)
    With sei
        .cbSize = Len(sei)
        .hWnd = GetDesktopWindow()
        .fMask = SEE_MASK_FLAG_NO_UI _
              Or SEE_MASK_CONNECTNETDRV _
              Or SEE_MASK_NOCLOSEPROCESS
        .nShow = SW_SHOWDEFAULT
        .lpVerb = "open"
    End With
End Sub
