Attribute VB_Name = "mdlRegistry"
Option Explicit
'****************************************************************************************************
'      : WW[
' @\Tv : WXg𑀍삷֐Q
' 쐬   : 2000/05/
' XV : 2001/02/10 wb_Rgt
'----------------------------------------------------------------------------------------------------
' ˑFile : Ȃ
'----------------------------------------------------------------------------------------------------
' l     :
'****************************************************************************************************

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As EnumHKEYs, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As EnumREGSUM, ByRef phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As EnumHKEYs, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As EnumREGTypes, ByVal lpData As Long, ByRef lpcbData As Long) As Long
Private Declare Function RegQueryValueExStr Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As EnumHKEYs, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As EnumREGTypes, ByVal lpData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As EnumHKEYs, ByVal dwIndex As Long, ByVal lpName As String, ByRef lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, ByRef lpcbClass As Long, ByRef lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
'--------------------------------------------------------------
Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type
'--------------------------------------------------------------
Private Enum EnumHKEYs
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum
Private Enum EnumREGTypes
    REG_NONE = 0
    REG_SZ = 1
    REG_EXPAND_SZ = 2
    REG_BINARY = 3
    REG_DWORD = 4
    REG_DWORD_LITTLE_ENDIAN = 4
    REG_DWORD_BIG_ENDIAN = 5
    REG_LINK = 6
    REG_MULTI_SZ = 7
    REG_RESOURCE_LIST = 8
    REG_FULL_RESOURCE_DESCRIPTOR = 9
    REG_RESOURCE_REQUIREMENTS_LIST = 10
End Enum
Private Enum EnumREGSUM
    KEY_QUERY_VALUE = &H1&
    KEY_SET_VALUE = &H2&
    KEY_CREATE_SUB_KEY = &H4&
    KEY_ENUMERATE_SUB_KEYS = &H8&
    KEY_NOTIFY = &H10&
    KEY_CREATE_LINK = &H20&
    KEY_READ = &H120019
    KEY_WRITE = &H120006
    KEY_EXECUTE = &H120000
    KEY_ALL_ACCESS = &H12003F
End Enum
'--------------------------------------------------------------
Private Const ERROR_SUCCESS = 0&
'**************************************************************

'=== w肵L[̒l擾 ===
Public Function GetRegValue(ByVal StrRegKey As String, Optional ByVal StrKeyName As String = "") As Variant
    Dim rtn As Long
'    Dim buf() As Byte
    Dim bufs As String
    Dim Size As Long
    Dim Key As Long
    Dim ValueType As Long
    
    '* WXgL[̃I[v
    Key = OpenRegistry(StrRegKey)
    If Key = 0 Then
        GetRegValue = Empty
        Exit Function
    End If
    
    '* l̎擾
    If StrKeyName = "" Then StrKeyName = vbNullChar
    'l̃TCY擾
    rtn = RegQueryValueEx(Key, StrKeyName, 0&, 0&, 0&, Size)
    If rtn <> ERROR_SUCCESS Then
        GetRegValue = Empty
        Call RegCloseKey(Key)
        Exit Function
    End If
    '擾TCYɒl擾
'    ReDim buf(Size - 1) As Byte
    bufs = Space$(Size)
    rtn = RegQueryValueExStr(Key, StrKeyName, 0&, ValueType, bufs, Size)
    If rtn <> ERROR_SUCCESS Then
        GetRegValue = Empty
        Call RegCloseKey(Key)
        Exit Function
    End If
    Select Case ValueType
     Case REG_SZ '
        GetRegValue = Left$(bufs, Size - 1)
    End Select
    
    '* WXgL[̃N[Y
    Call RegCloseKey(Key)
End Function

' === w肵L[ȉ̃L[Xg擾 ===
Public Function GetRegEnumKey(ByVal StrRegKey As String) As String()
    Dim Key As Long
    Dim Index As Long
    Dim buf As String
    Dim Size As Long
    Dim ft As FILETIME
    Dim KeyList() As String
    Dim rtn As Long
    
    KeyList = Split("")
    
    '* WXgL[̃I[v
    Key = OpenRegistry(StrRegKey, KEY_READ)
    If Key = 0 Then
        GetRegEnumKey = KeyList
        Erase KeyList
        Exit Function
    End If
    
    '* L[̗
    Index = 0
    Size = 1024: buf = Space$(Size)
    rtn = RegEnumKeyEx(Key, Index, buf, Size, 0&, 0&, 0&, ft)
    Do While rtn = ERROR_SUCCESS
        ReDim Preserve KeyList(UBound(KeyList) + 1) As String
        KeyList(UBound(KeyList)) = Left$(buf, InStr(buf, vbNullChar) - 1)
        Size = 1024: buf = Space$(Size)
        Index = Index + 1
        rtn = RegEnumKeyEx(Key, Index, buf, Size, 0&, 0&, 0&, ft)
    Loop
    
    '* WXgL[̃N[Y
    Call RegCloseKey(Key)
    
    GetRegEnumKey = KeyList
    Erase KeyList
End Function

' === WXgL[̃I[v
Private Function OpenRegistry(ByVal StrRegKey As String, Optional ByVal AccessMask As EnumREGSUM = KEY_QUERY_VALUE) As Long
    Dim rtn As Long
    Dim TopKey As EnumHKEYs
    Dim SubKey As String
    Dim Key As Long
    
    'gbvx̃L[擾
    Select Case Left$(StrRegKey, InStr(StrRegKey, "\") - 1)
     Case "HKEY_CLASSES_ROOT"
        TopKey = HKEY_CLASSES_ROOT
     Case "HKEY_CURRENT_USER"
        TopKey = HKEY_CURRENT_USER
     Case "HKEY_LOCAL_MACHINE"
        TopKey = HKEY_LOCAL_MACHINE
     Case "HKEY_USERS"
        TopKey = HKEY_USERS
     Case "HKEY_PERFORMANCE_DATA"
        TopKey = HKEY_PERFORMANCE_DATA
     Case "HKEY_CURRENT_CONFIG"
        TopKey = HKEY_CURRENT_CONFIG
     Case "HKEY_DYN_DATA"
        TopKey = HKEY_DYN_DATA
    End Select
    
    'TuL[擾
    SubKey = Mid$(StrRegKey, InStr(StrRegKey, "\") + 1)
    If SubKey = "" Then SubKey = vbNullChar
    rtn = RegOpenKeyEx(TopKey, SubKey, 0&, AccessMask, OpenRegistry)
    If rtn <> ERROR_SUCCESS Then OpenRegistry = 0
End Function
