VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CIniFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'****************************************************************************************************
'      : NX()
' @\Tv : INIt@C𑀍삷NX
' 쐬   : 2000/05/
' XV : 2001/04/20 wb_Rgt
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile : Ȃ
'****************************************************************************************************

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function GetPrivateProfileSectionNames Lib "kernel32" Alias "GetPrivateProfileSectionNamesA" (ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
'**************************************************************

Private mIniFileName As String
Private mNowSection As String
Private mDataList As Collection
Private mIsExist As Boolean

Private mSections As Collection
Private mKeys As Collection

Public Enum EnumIniType
    eIniType_String
    eIniType_Long
    eIniType_Single
    eIniType_Boolean
    eIniType_Date
End Enum

Public Function Load(ByVal IniFileName As String) As Boolean
    Dim Section As Variant
    Dim Key As Variant
    Dim mKey As Collection
    Dim buf As String, Size As Long
    Dim rtn As Long

    mIniFileName = IniFileName
    Set mSections = New Collection
    Set mDataList = New Collection
    
    'ZNVXg擾
    Size = 1024
    buf = Space$(Size)
    rtn = GetPrivateProfileSectionNames(buf, Size, IniFileName)
    Do While rtn = Size - 2
        Size = Size + 1024
        buf = Space$(Size)
        rtn = GetPrivateProfileSectionNames(buf, Size, IniFileName)
    Loop
    If rtn = 1 Then
        Load = False
        Exit Function
    End If
    buf = Left$(buf, rtn)
    
    'ZNVƂɃL[ƃf[^̃Xg擾
    For Each Section In Split(buf, vbNullChar)
        If Trim$(Section) <> "" Then
            Call mSections.Add(Section, Section)
            Set mKey = New Collection
            Call mDataList.Add(mKey, Section)
            Set mKey = Nothing
            
            Size = 4096
            buf = Space$(Size)
            rtn = GetPrivateProfileSection(Section, buf, Size, IniFileName)
            Do While rtn = Size - 2
                Size = Size + 1024
                buf = Space$(Size)
                rtn = GetPrivateProfileSection(Section, buf, Size, IniFileName)
            Loop
            If rtn > 1 Then
                buf = Left$(buf, rtn)
                
                For Each Key In Split(buf, vbNullChar)
                    If Trim$(Key) <> "" Then
                        On Error Resume Next
                        Call mDataList(Section).Remove(LCase$(Split(Key, "=", 2)(0)))
                        Call mDataList(Section).Add(Replace$(Key, "=", vbNullChar, , 1), LCase$(Split(Key, "=", 2)(0)))
                        On Error GoTo 0
                    End If
                Next Key
            End If
        End If
    Next Section
    
'    Me.NowSection = mSections(1)
    mIsExist = False
    Load = True
End Function

Public Function Save(Optional ByVal Section As String = "") As Boolean
    Dim sec As Variant
    
    'ZNVɕۑ
    If Section = "" Then
        For Each sec In Me.Sections
            Save = SaveSection(sec)
            If Not Save Then Exit For
        Next sec
    Else
        Save = SaveSection(Section)
    End If
End Function
Private Function SaveSection(ByVal Section As String) As Boolean
    Dim Key As Variant
    Dim rtn As Long
    Dim buf As String
    
    SaveSection = True
    Me.NowSection = Section
    For Each Key In Me.Keys
        buf = buf & CStr(Key) & "=" & Me.Data(Key) & vbNullChar
    Next Key
    buf = buf & vbNullChar
    
    rtn = WritePrivateProfileSection(Section, buf, mIniFileName)
    If rtn = 0 Then
        SaveSection = False
        Exit Function
    End If
    mIsExist = True
End Function

Public Property Get NowSection() As String
    NowSection = mNowSection
End Property
Public Property Let NowSection(ByVal NewSection As String)
    Dim buf As Variant
    Dim mKey As Collection
    
    If NewSection = mNowSection Then Exit Property

    On Error Resume Next
    mNowSection = mSections(NewSection)
    If Err.Number = 5 Then
        mNowSection = NewSection
        Call mSections.Add(NewSection, NewSection)
        Set mKey = New Collection
        Call mDataList.Add(mKey, NewSection)
        Set mKey = Nothing
        mIsExist = False
    Else
        mIsExist = True
    End If
    On Error GoTo 0

    Set mKeys = Nothing
    Set mKeys = New Collection
    For Each buf In mDataList(mNowSection)
        If InStr(buf, vbNullChar) > 0 Then
            buf = Left(buf, InStr(buf, vbNullChar) - 1)
            Call mKeys.Add(buf, buf)
        End If
    Next buf
End Property

Public Property Get IsExist() As Boolean
    IsExist = mIsExist
End Property

Public Property Get Sections() As Collection
    Set Sections = mSections
End Property

Public Property Get Keys() As Collection
    Set Keys = mKeys
End Property

Public Sub DeleteData(ByVal Key As String)
    On Error Resume Next
    Call mDataList(mNowSection).Remove(Key)
    Call Keys.Remove(Key)
End Sub

Public Sub Clear()
    Dim Key As Variant
    For Each Key In Me.Keys
        Call Me.DeleteData(Key)
    Next Key
End Sub

Public Property Get Data(ByVal Key As String) As String
Attribute Data.VB_UserMemId = 0
    Dim buf As String
    On Error Resume Next
    buf = mDataList(mNowSection)(Key)
    If Err.Number = 5 Then
        Data = ""
    ElseIf buf = "" Then
        Data = ""
    Else
        Data = Mid$(buf, InStr(buf, vbNullChar) + 1)
    End If
End Property
Public Property Let Data(ByVal Key As String, ByVal NewData As String)
    On Error Resume Next
    Call DeleteData(Key)
    On Error GoTo 0
    Call mDataList(mNowSection).Add(Key & vbNullChar & NewData, Key)
    Call Keys.Add(Key, Key)
End Property

Public Function InitData(ByVal Key As String, ByVal IniType As EnumIniType, ByVal Default As Variant) As Variant
    Select Case IniType
     Case eIniType_String
        If Trim$(Me.Data(Key)) <> "" Then
            InitData = Me.Data(Key)
        Else
            InitData = Default
        End If
    
     Case eIniType_Long
        If IsLng(Me.Data(Key)) Then
            InitData = CLng(Me.Data(Key))
        Else
            InitData = Default
        End If
        
     Case eIniType_Single
        If IsSng(Me.Data(Key)) Then
            InitData = CSng(Me.Data(Key))
        Else
            InitData = Default
        End If
        
     Case eIniType_Boolean
        If IsBool(Me.Data(Key)) Then
            InitData = CBool(Me.Data(Key))
        Else
            InitData = Default
        End If
        
     Case Else
        InitData = Me.Data(Key)
        
    End Select
End Function


' === Boolean^ɕϊł邩`FbN ===
Public Function IsBool(ByVal Str As String) As Boolean
    Dim rtn As Boolean
    On Error Resume Next
    rtn = CBool(Str)
    IsBool = (Err.Number = 0)
End Function

' === Integer^ɕϊł邩`FbN ===
Public Function IsInt(ByVal Str As String) As Boolean
    Dim rtn As Integer
    On Error Resume Next
    rtn = CInt(Str)
    IsInt = (Err.Number = 0)
End Function

' === Long^ɕϊł邩`FbN ===
Public Function IsLng(ByVal Str As String) As Boolean
    Dim rtn As Integer
    On Error Resume Next
    rtn = CLng(Str)
    IsLng = (Err.Number = 0)
End Function

' === Single^ɕϊł邩`FbN ===
Public Function IsSng(ByVal Str As String) As Boolean
    Dim rtn As Integer
    On Error Resume Next
    rtn = CSng(Str)
    IsSng = (Err.Number = 0)
End Function


