VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CMRUCombo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'****************************************************************************************************
'      : NX()
' @\Tv : R{{bNXMRU@\t
' 쐬   : 2000/05/
' XV : 2001/04/20 wb_Rgt
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile : Ȃ
'****************************************************************************************************


'====================================================================================================
' vCx[gȕϐ
'====================================================================================================
Private WithEvents cmbAC As ComboBox        'MRU@\tR{{bNX
Attribute cmbAC.VB_VarHelpID = -1

Private SelStart As Integer                 '݂̃J[\ʒuۑĂ
                                            '̃CxgvV[WŗpׁÄʒu

'ۑΏۂMRU
Private m_SavedMRUList As Collection
Private m_SavedMRUMax As Integer



'====================================================================================================
' JvpeB
'====================================================================================================
Public Property Set ComboBox(ByRef NewComboBox As ComboBox)
'----------------------------------------------------
'      : vpeB(p(?))
' @\Tv : MRU@\tR{{bNX
' 쐬   : 2001/02/17
' XV :
' l     : xlZbgAύXȂ悤ɂȂƂ܂낤ˁB
'----------------------------------------------------
    Set cmbAC = NewComboBox
    Set m_SavedMRUList = New Collection
    m_SavedMRUMax = 0
End Property

Public Property Get Max() As Integer
'----------------------------------------------------
'      : vpeB(Ǐp)
' @\Tv : MRUۑłől
' 쐬   : 2001/02/17
' XV :
'----------------------------------------------------
    Max = m_SavedMRUMax
End Property
Public Property Let Max(ByVal NewMax As Integer)
    m_SavedMRUMax = NewMax
    Call RefreshMRU
End Property

Public Property Get MRUList() As Collection
'----------------------------------------------------
'      : vpeB(ǎp)
' @\Tv : MRŨXg
' 쐬   : 2001/02/17
' XV :
'----------------------------------------------------
    Set MRUList = m_SavedMRUList
End Property



'====================================================================================================
' J郁\bh
'====================================================================================================
Public Sub AddMRU(Optional ByVal strText As String = vbNullChar, Optional ByVal AddFirst As Boolean = True)
'----------------------------------------------------
'      : \bh
' @\Tv : JMRUXgɕۑMRUǉ
'      : strText    : ǉEۑeLXg(ȗ΁AR{{bNX̒l)
'          : AddFirst   : 擪ɒǉȂTrue
' ߂l   : Ȃ
' 쐬   : 2001/02/17
' XV :
'----------------------------------------------------
    If strText = vbNullChar Then
        strText = cmbAC.Text
    End If
    
    On Error Resume Next
    Call m_SavedMRUList.Remove(strText)
    On Error GoTo 0
    If m_SavedMRUList.Count = 0 Or Not AddFirst Then
        Call m_SavedMRUList.Add(strText, strText)
    Else
        Call m_SavedMRUList.Add(strText, strText, 1)
    End If
    Call RefreshMRU

    'ComboBoxAddItem
    Call AddMRUTemp(strText, AddFirst)
End Sub

Public Sub AddMRUTemp(Optional ByVal strText As String = vbNullChar, Optional ByVal AddFirst As Boolean = True)
'----------------------------------------------------
'      : \bh
' @\Tv : JMRUXgɕۑȂMRUǉ
'      : strText    : ǉeLXg(ȗ΁AR{{bNX̒l)
'          : AddFirst   : 擪ɒǉȂTrue
' ߂l   : Ȃ
' 쐬   : 2001/02/17
' XV :
'----------------------------------------------------
    Dim i As Integer
    Dim prevComboText As String
    
    prevComboText = cmbAC.Text
    
    If strText = vbNullChar Then
        strText = cmbAC.Text
    End If
    
    For i = 0 To cmbAC.ListCount - 1
        If cmbAC.list(i) = strText Then
            Call cmbAC.RemoveItem(i)
            Exit For
        End If
    Next i
    If AddFirst Then
        Call cmbAC.AddItem(strText, 0)
    Else
        Call cmbAC.AddItem(strText)
    End If
    Call RefreshMRU
    
    cmbAC.Text = prevComboText
End Sub



'====================================================================================================
' CxgvV[W
'====================================================================================================
Private Sub Class_Initialize()
    m_SavedMRUMax = 10
End Sub

Private Sub Class_Terminate()
    Set cmbAC = Nothing
End Sub

Private Sub cmbAC_Change()
    Static prevText As String
    Static flgChange As Boolean
    Dim i As Integer, j As Integer
    Dim c As String, pos As Integer
    Dim MRUList() As String, Find As String

    'I[gRNgȂ珈Ȃ
    If flgChange Then Exit Sub
    
    'OƓȂ牽Ȃ
    If prevText = cmbAC.Text Then Exit Sub
    
    'J[\ʒuOOȂ牽Ȃ
    If SelStart >= cmbAC.SelStart Then
        SelStart = cmbAC.SelStart
        Exit Sub
    End If

    'I[gRNg̑ΏۂƂȂMRUQ擾
    MRUList = Split("")
    Find = cmbAC.Text
    Find = Replace$(Find, "[", "[[]")
    Find = Replace$(Find, "#", "[#]")
    Find = Replace$(Find, "*", "[*]")
    Find = Replace$(Find, "?", "[?]")
    Find = Find & "*"
    For i = 0 To cmbAC.ListCount - 1
        If cmbAC.list(i) Like Find Then
            ReDim Preserve MRUList(UBound(MRUList) + 1) As String
            MRUList(UBound(MRUList)) = cmbAC.list(i)
        End If
    Next i
        

    'MRUQȂΏI
    If UBound(MRUList) < 0 Then
        prevText = cmbAC.Text
        Exit Sub
    End If

    'TCY̑傫ɕёւ
    For i = 0 To UBound(MRUList) - 1
        For j = i + 1 To UBound(MRUList)
            If Len(MRUList(i)) < Len(MRUList(j)) Then
                c = MRUList(i)
                MRUList(i) = MRUList(j)
                MRUList(j) = c
            End If
        Next j
    Next i

    'ǂ܂œȁH
    pos = Len(cmbAC.Text)
    Do While pos < Len(MRUList(0))
        pos = pos + 1
        c = Mid$(MRUList(0), pos, 1)
        For i = 1 To UBound(MRUList)
            If c <> Mid$(MRUList(i) & String(Len(MRUList(0)), vbNullChar), pos, 1) Then
                pos = pos - 1
                Exit Do
            End If
        Next i
    Loop

    'Ƃ܂łǉ
    SelStart = Len(cmbAC.Text)
    flgChange = True
    cmbAC.Text = Left$(MRUList(0), pos)
    flgChange = False
    cmbAC.SelStart = SelStart
    cmbAC.SelLength = Len(cmbAC.Text) - SelStart

    prevText = cmbAC.Text
End Sub
Private Sub cmbAC_KeyDown(KeyCode As Integer, Shift As Integer)
    SelStart = cmbAC.SelStart
End Sub

Private Sub cmbAC_KeyPress(KeyAscii As Integer)
    '[Tab]L[ȂI͈͉
    If KeyAscii = vbKeyTab Then
        With cmbAC
            If .SelLength > 0 Then
                .SelStart = .SelStart + .SelLength
            End If
        End With
    End If
End Sub



'====================================================================================================
' J֐
'====================================================================================================
Private Sub RefreshMRU()
'----------------------------------------------------
'      : vV[W
' @\Tv : MRU̕ۑɉāAÂMRU폜
'      : Ȃ
' ߂l   : Ȃ
' 쐬   : 2001/02/17
' XV :
'----------------------------------------------------
    'Max = -1Ȃ疳ɓo^
    If Me.Max = -1 Then Exit Sub
    
    With m_SavedMRUList
        Do While .Count > Me.Max
            Call .Remove(.Count)
        Loop
    End With
End Sub
