Attribute VB_Name = "mdlWindow"
Option Explicit
'****************************************************************************************************
'      : WW[()
' @\Tv : EBhEɑ΂鑀֐Q
' 쐬   : 2000/05/
' XV : 2001/04/20 wb_Rgt
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile : Ȃ
'****************************************************************************************************

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
Private Const API_NULL  As Long = &H0
'--------------------------------------------------------------
Private Declare Function AttachThreadInput Lib "user32" (ByVal idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach As Long) As Long
Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function FindWindow_api Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetClassName_api Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
'''Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
'''Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetWindowPlacement Lib "user32" (ByVal hWnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowText_api Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, ByRef lpdwProcessId As Long) As Long
Private Declare Function IsIconic Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function IsZoomed Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
'''Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
'--------------------------------------------------------------
Public Type WINDOW_TWIP_SIZE
    Left As Single
    Top As Single
    Width As Single
    Height As Single
End Type

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Type WINDOWPLACEMENT
        Length As Long
        flags As Long
        showCmd As Long
        ptMinPosition As POINTAPI
        ptMaxPosition As POINTAPI
        rcNormalPosition As RECT
End Type
'--------------------------------------------------------------
Public Enum EnumHitTestResize
    HTCLIENT = 1
    HTLEFT = 10
    HTRIGHT = 11
    HTTOP = 12
    HTTOPLEFT = 13
    HTTOPRIGHT = 14
    HTBOTTOM = 15
    HTBOTTOMLEFT = 16
    HTBOTTOMRIGHT = 17
End Enum
'--------------------------------------------------------------
Private Const HWND_BOTTOM       As Long = 1
Private Const HWND_TOP          As Long = 0
Private Const HWND_TOPMOST      As Long = (-1)
Private Const HWND_NOTOPMOST    As Long = (-2)
Private Const SWP_NOSIZE        As Long = &H1
Private Const SWP_NOMOVE        As Long = &H2
Private Const SW_RESTORE        As Long = 9
Private Const HTCAPTION         As Long = 2
Private Const WM_NCLBUTTONDOWN  As Long = &HA1
Private Const SPI_GETWORKAREA   As Long = 48
Private Const GWL_STYLE         As Long = (-16)
Private Const GWL_EXSTYLE       As Long = (-20)
Private Const WS_EX_TOOLWINDOW  As Long = &H80
Private Const WS_EX_APPWINDOW   As Long = &H40000
Private Const WS_BORDER         As Long = &H800000
'**************************************************************

Public Enum EnumHWND_ZOrder
    TOP_MOST
    BOTTOM_MOST
    RESTORE
End Enum

Public Enum EnumMoveWindowMode
    MWM_Normal
    MWM_Center
    MWM_LimitScreen
    MWM_PutScreen
    MWM_PutAntherWindow
End Enum

Private mWindowList() As Long

' === EBhET ===
Public Function FindWindow(ByVal ClassName As String, ByVal Caption As String) As Long
    FindWindow = FindWindow_api(ClassName, Caption)
End Function

' === tH[őOʂɕ\ ===
Public Sub TopMostForm(ByVal hWnd As Long, Optional ByVal flgTopMost As Boolean = True)
    If flgTopMost Then
        Call SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    Else
        Call SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    End If
End Sub

' === tH[ZOrderς ===
Public Sub ChangeFormZOrder(ByVal hWnd As Long, ByVal flgTopMost As EnumHWND_ZOrder)
    Select Case flgTopMost
     Case TOP_MOST
        Call SetParent(hWnd, API_NULL)
        Call SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
     Case BOTTOM_MOST
        Call SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
        Call SetParent(hWnd, FindWindow("Progman", "Program Manager"))
     Case RESTORE
        Call SetParent(hWnd, API_NULL)
        Call SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    End Select
End Sub

' === mɃEBhEOʂɕ\ ===
Public Function ActiveWindow(ByVal hWnd As Long, Optional ByVal NowThreadID As Long = 0) As Boolean
    Dim myThreadID As Long
    
    If NowThreadID = 0 Then
        NowThreadID = GetWindowThreadProcessId(GetForegroundWindow(), 0&)
    End If
    myThreadID = GetWindowThreadProcessId(hWnd, 0&)
    Call AttachThreadInput(myThreadID, NowThreadID, API_TRUE)
    If Not IsZoomed(hWnd) <> API_FALSE Then
        Call ShowWindow(hWnd, SW_RESTORE)
    End If
    Call SetForegroundWindow(hWnd)
    Call AttachThreadInput(myThreadID, NowThreadID, API_FALSE)
    
    ActiveWindow = True
End Function

' === gANeBuǂׂ ===
Public Function IsActive(ByVal hWnd As Long) As Boolean
    Dim NowhWnd As Long
    
    NowhWnd = GetForegroundWindow()
    IsActive = (NowhWnd = hWnd)
End Function

' === tH[𓮂bZ[W𑗂 ===
Public Sub MoveForm(ByVal hWnd As Long)
    Dim pt As POINTAPI
    Call GetCursorPos(pt)
    Call ReleaseCapture
    Call SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, CLng(pt.Y * &H10000 + pt.X))
End Sub

' === tH[̃TCYύXbZ[W𑗂 ===
Public Sub ResizeForm(ByVal hWnd As Long, ByVal Direction As EnumHitTestResize)
    Dim pt As POINTAPI
    Call GetCursorPos(pt)
    Call ReleaseCapture
    Call SendMessage(hWnd, WM_NCLBUTTONDOWN, Direction, CLng(pt.Y * &H10000 + pt.X))
End Sub

' === EBhẼ^Cg擾 ===
Public Function GetWindowText(ByVal hWnd As Long) As String
    Dim Length As Long
    Dim buf As String
    
    Length = GetWindowTextLength(hWnd)
    buf = Space$(Length + 1)
    Call GetWindowText_api(hWnd, buf, Length + 1)
    GetWindowText = Left$(buf, InStr(buf & vbNullChar, vbNullChar) - 1)
End Function

' === EBhENX擾 ===
Public Function GetClassName(ByVal hWnd As Long) As String
    Dim Length As Long
    Dim rtn As Long
    Dim buf As String
    
    Length = 0
    Do
        Length = Length + 1024
        buf = Space$(Length + 1)
        rtn = GetClassName_api(hWnd, buf, Length + 1)
    Loop While rtn >= Length
    GetClassName = Left$(buf, InStr(buf & vbNullChar, vbNullChar) - 1)
End Function

' === ʏ펞̉ʃTCY擾 ===
Public Function GetNormalSize(ByVal hWnd As Long) As WINDOW_TWIP_SIZE
    Dim wp As WINDOWPLACEMENT
    
    wp.Length = Len(wp)
    Call GetWindowPlacement(hWnd, wp)
    
    With wp.rcNormalPosition
        GetNormalSize.Left = .Left * Screen.TwipsPerPixelX
        GetNormalSize.Top = .Top * Screen.TwipsPerPixelY
        GetNormalSize.Width = (.Right - .Left) * Screen.TwipsPerPixelX
        GetNormalSize.Height = (.Bottom - .Top) * Screen.TwipsPerPixelY
    End With
End Function

' === EBhE񋓂 ===
Public Function GetWindowList() As Long()
    Erase mWindowList
    ReDim mWindowList(0) As Long
    Call EnumWindows(AddressOf EnumWindowsProc, 0&)
    GetWindowList = mWindowList
End Function
Public Function EnumWindowsProc(ByVal hWnd As Long, ByVal lParam As Long) As Boolean
    EnumWindowsProc = True
    
    'Xgɒǉ
    ReDim Preserve mWindowList(UBound(mWindowList) + 1) As Long
    mWindowList(UBound(mWindowList)) = hWnd
End Function

' === ĂEBhE񋓂 ===
Public Function GetVisibleWindowList() As Long()
    Dim i As Long
    Dim WindowList() As Long
    
    ReDim mWindowList(0) As Long
    
    'EBhEXg̎擾
    WindowList = GetWindowList()
    
    For i = LBound(WindowList) To UBound(WindowList)
        If GetVisibleWindowListSub(WindowList(i)) Then
            ReDim Preserve mWindowList(UBound(mWindowList) + 1) As Long
            mWindowList(UBound(mWindowList)) = WindowList(i)
        End If
    Next i
    
    GetVisibleWindowList = mWindowList
End Function
Private Function GetVisibleWindowListSub(ByVal hWnd As Long) As Boolean
    Dim rc As RECT
    
    'ĂȂ΃LZ
    If IsWindowVisible(hWnd) = API_FALSE Then Exit Function

    'TCYȂ΃LZ
    If GetWindowRect(hWnd, rc) = API_FALSE Then Exit Function
    If (rc.Left = rc.Right) Or (rc.Top = rc.Bottom) Then Exit Function

    'ő剻AŏĂ΃LZ
    If IsIconic(hWnd) Then Exit Function
    If IsZoomed(hWnd) Then Exit Function
    
    GetVisibleWindowListSub = True
End Function

''''''*** GetWindowList𗘗pē̏悤ɂ邱
''''''' === ^XNo[ɕ\ĂEBhE񋓂 ===
''''''Public Function GetTaskWindowList() As Long()
''''''    Erase mWindowList
''''''    ReDim mWindowList(0) As Long
''''''    Call EnumWindows(AddressOf EnumTaskWindowsProc, 0&)
''''''    GetTaskWindowList = mWindowList
''''''End Function
''''''Public Function EnumTaskWindowsProc(ByVal hWnd As Long, ByVal lParam As Long) As Boolean
''''''    Dim exStyle As Long
''''''    Dim rc As RECT
''''''
''''''    EnumTaskWindowsProc = True
''''''
''''''    'ĂȂ΃LZ
''''''    If IsWindowVisible(hWnd) = API_FALSE Then Exit Function
''''''
''''''    exStyle = GetWindowLong(hWnd, GWL_EXSTYLE)
''''''
''''''    'WS_EX_TOOLWINDOWȂ΃LZ
''''''    If (exStyle And WS_EX_TOOLWINDOW) = WS_EX_TOOLWINDOW Then Exit Function
''''''
''''''    'WS_EX_APPWINDOWȂOK
''''''    'WS_EX_APPWINDOWłWS_EX_TOOLWINDOWłȂeEBhEȂȂOK
''''''    If Not (((exStyle And WS_EX_APPWINDOW) = WS_EX_APPWINDOW) _
''''''       Or ((exStyle And (WS_EX_APPWINDOW Or WS_EX_TOOLWINDOW)) <> (WS_EX_APPWINDOW Or WS_EX_TOOLWINDOW) _
''''''       And (GetParent(hWnd) = API_FALSE))) Then Exit Function
''''''
''''''    'TCYȂ΃LZ
''''''    If GetWindowRect(hWnd, rc) = API_FALSE Then Exit Function
''''''    If (rc.Left = rc.Right) Or (rc.Top = rc.Bottom) Then Exit Function
''''''
''''''    'Xgɒǉ
''''''    ReDim Preserve mWindowList(UBound(mWindowList) + 1) As Long
''''''    mWindowList(UBound(mWindowList)) = hWnd
''''''End Function

'ʃTCY擾
Public Sub GetScreenSize(ByRef Width As Long, ByRef Height As Long)
    Dim rc As RECT
    Call SystemParametersInfo(SPI_GETWORKAREA, 0&, rc, 0&)
    Width = (rc.Right - rc.Left)
    Height = (rc.Bottom - rc.Top)
End Sub



